[PATCH 4/5] erofs-utils: tests: add test for xattr crossing block boundary
Jingbo Xu
jefflexu at linux.alibaba.com
Thu May 25 18:32:00 AEST 2023
Test the extended attribute which crosses block boundary.
Signed-off-by: Jingbo Xu <jefflexu at linux.alibaba.com>
---
tests/Makefile.am | 3 +++
tests/common/rc | 6 ++++++
tests/erofs/021 | 60 +++++++++++++++++++++++++++++++++++++++++++++++++++++
tests/erofs/021.out | 2 ++
4 files changed, 71 insertions(+)
create mode 100755 tests/erofs/021
create mode 100644 tests/erofs/021.out
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 1d6ea5c..61bbb4d 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -94,6 +94,9 @@ TESTS += erofs/019
# 020 - check extended attributes in different layouts
TESTS += erofs/020
+# 021 - check extended attributes crossing block boundary
+TESTS += erofs/021
+
EXTRA_DIST = common/rc erofs
clean-local: clean-local-check
diff --git a/tests/common/rc b/tests/common/rc
index 293e556..0361c68 100644
--- a/tests/common/rc
+++ b/tests/common/rc
@@ -92,6 +92,12 @@ _require_xattr()
_notrun "attr isn't installed, skipped."
}
+_require_mkfs_blksize()
+{
+ "$MKFS_EROFS_PROG" --help 2>&1 | grep -q -- '-b#' ||
+ _notrun "-b# feature needed for mkfs.erofs"
+}
+
# this test requires erofs kernel support
_require_erofs()
{
diff --git a/tests/erofs/021 b/tests/erofs/021
new file mode 100755
index 0000000..d36aa56
--- /dev/null
+++ b/tests/erofs/021
@@ -0,0 +1,60 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0+
+#
+# 021 - check extended attributes crossing block boundary
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$(echo $0 | awk '{print $((NF-1))"/"$NF}' FS="/")
+
+# get standard environment, filters and checks
+. "${srcdir}/common/rc"
+
+cleanup()
+{
+ cd /
+ rm -rf $tmp.*
+}
+
+_require_erofs
+_require_xattr
+_require_mkfs_blksize
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+echo "QA output created by $seq"
+
+if [ -z $SCRATCH_DEV ]; then
+ SCRATCH_DEV=$tmp/erofs_$seq.img
+ rm -f SCRATCH_DEV
+fi
+
+localdir="$tmp/$seq"
+rm -rf $localdir
+mkdir -p $localdir
+
+# set inline xattr (large name/value crossing block boundary)
+# given blksize will be set to 512 later, it is ensured that xattr values
+# cross the block boundary; besides set three xattrs to ensure at least
+# one xattr name crosses the block boundary
+touch $localdir/file1
+for i in {1..3}; do
+ setfattr -n user.p$(_random 249) -v $(_random 512) $localdir/file1 \
+ || _notrun "no space for xattrs"
+done
+
+# specify 512 blocksize explicitly so that the large name/value of file1
+# could cross the block boundary
+MKFS_OPTIONS="$MKFS_OPTIONS -b512"
+_scratch_mkfs $localdir >> $seqres.full 2>&1 || _fail "failed to mkfs"
+_scratch_mount 2>>$seqres.full
+
+# check xattrs
+_check_xattrs $localdir $SCRATCH_MNT
+
+_scratch_unmount
+
+echo Silence is golden
+status=0
+exit 0
diff --git a/tests/erofs/021.out b/tests/erofs/021.out
new file mode 100644
index 0000000..09f4062
--- /dev/null
+++ b/tests/erofs/021.out
@@ -0,0 +1,2 @@
+QA output created by 021
+Silence is golden
--
1.8.3.1
More information about the Linux-erofs
mailing list